        .XLIST
        PAGE    60,132
        TITLE   C2PCX - Create .PCX file from BIG-5 file
;*****************************************************************
;*                                                               *
;*  C2PCX - Create .PCX file from BIG-5 code                     *
;*                                                               *
;*  USAGE: C2PCX filename /s:size /l:line gap /c:char gap        *
;*                                                               *
;*      size = character size - 15, 24                           *
;*      line gap = line gap in dots                              *
;*      char gap = char gap in dots                              *
;*                                                               *
;* BIG-5 code: First byte = A1-FE; Second byte = 40-7E, A1-FE    *
;*                                                               *
;* Font file format:                                             *
;*      c2pcx.15 -                                               *
;*         0000    256 x 1 x 15   00-FF    ASCII han-asc.15      *
;*         0F00    408 x 2 x 15 A140-A3BF  SYMBO han-gr.15       *
;*         3ED0   5401 x 2 x 15 A440-C67E  FREQU han-std1.15     *
;*        2B7BE   7693 x 2 x 15 C940-F9FE  OCCAS han-std2.15     *
;*        63D44    318 x 2 x 15 C6E7-C7F2  JAPAN han-gr1.15      *
;* total  66288 (418,440) bytes                                  *
;*      c2pcx.24 -                                               *
;*         0000    256 x 2 x 24   00-FF    ASCII han-asc.24      *
;*         3000    408 x 3 x 24 A140-A3BF  SYMBO han-gr.24       *
;*         A2C0   5401 x 3 x 24 A440-C67E  FREQU han-std1.24     *
;*        691C8   7693 x 3 x 24 C940-F9FE  OCCAS han-std2.24     *
;*        F0570    318 x 3 x 24 C6E7-C7F2  JAPAN han-gr1.24      *
;* total  F5EE0 (1,007,328) bytes                                *
;*****************************************************************
	CSEG	SEGMENT
	ASSUME	CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
;
PRTCHR	MACRO	X		;print character
	IFNB	<X>
	MOV	AL, X
	ENDIF
	MOV	BX,0EH
	MOV	AH,14
	INT	10H
	ENDM
;
PRTSTR	MACRO	X
	MOV	DX,OFFSET X
	MOV	AH,9
	INT	21H
	ENDM
;************************
;* Initialization	*
;************************
	ORG	100H
BEGIN:	MOV	SP,OFFSET STK
	PRTSTR	MSG0		;print greeting message
	CALL	PARSE		;get command line parameters
	JNC	F100
        JMP     EXIT
;
; Initializer variables
;
F100:   MOV     AX,[CSIZE]
        ADD     AX,[LINEGAP]
        MOV     [LHEIGHT],AX    ;line height
;
; Open font file
;
        MOV     DX,OFFSET FNTNAM
	MOV	AL,0			;open for reading
	MOV	AH,3DH
	INT	21H			;open font file
	JNC	F110
	PRTSTR	MSG2
	JMP	EXIT
;
F110:	MOV	[RHANDLE],AX		;save output file handle
;
; Setup VSCREEN image area (segment=VSCREEN, length=NXTLIN segments)
;
        MOV     BX,OFFSET STK           ;bx = end of program
	ADD	BX,15
	SHR	BX,1
	SHR	BX,1
	SHR	BX,1
	MOV	AX,DS
	ADD	BX,AX
        MOV     [VSCREEN],BX            ;[vscreen] = segment number of image
;
; determine ASCII half word pattern size
;
        MOV     AX,[CSIZE]
        SHR     AX,1
        ADD     AX,7
        SHR     AX,1
        SHR     AX,1
        SHR     AX,1
        MOV     BX,[CSIZE]
        MUL     BX
        MOV     BYTE PTR[ASCSIZ],0
        MOV     WORD PTR[ASCSIZ+1],AX
        MOV     BYTE PTR[ASCSIZ+3],DL
;
; Setup VSCREEN, NXTLIN
;
        MOV     AX,[WIDT]
        ADD     AX,127
        SHL     AH,1
        MOV     AL,AH
        MOV     AH,0
        MOV     [NXTLIN],AX
;
; Clear image area
;
        MOV     AX,40H
        MOV     ES,AX
        MOV     AX,ES:[13H]             ;AX=memory size in Kbytes
        MOV     CL,6
        REP     SHL AX,CL               ;AX=memory size in 16-byte segments
        DEC     AX
        MOV     [LASTSEG],AX
;
	MOV	ES,[VSCREEN]
F115:   MOV     BX,0
        MOV     AX,BX
        MOV     CX,16
;
F120:	MOV	ES:[BX],AX
	INC	BX
        LOOP    F120
;
        MOV     AX,ES
        INC     AX
        MOV     ES,AX
        CMP     AX,[LASTSEG]
        JB      F115
;
; Open input file
;
        MOV     DX,OFFSET FILNAM
	MOV	AL,0			;open for reading
	MOV	AH,3DH
        INT     21H
        JNC     F123
        PRTSTR  MSG5
	JMP	EXIT
;
F123:   MOV     [FHANDLE],AX            ;save input file handle
        MOV     [LINES],1
        .LIST
;
; Create image
;
	MOV	AX,[VSCREEN]
	MOV	[VSEG],AX
	MOV	[VBPTR],0
F140:   CALL    RDWORD                  ;AH = high byte, AL = low byte
;
        CMP     AH,1AH
        JE      F200                    ;end of file
;
        CMP     AX,000DH
        JE      F140
;
        CMP     AX,000AH
        JNE     F142
        MOV     AX,[NXTLIN]
        MUL     [LHEIGHT]
        ADD     [VSEG],AX
        MOV     [VBPTR],0
        INC     [LINES]
        JMP     F140
;
F142:   CALL    GETFNT                  ;read pattern of AH:AL into VSEG:VBPTR
        MOV     AX,[CWIDTH]
	ADD	[VBPTR],AX
	JMP	F140
;
; Write .PCX file
;
F200:   MOV     DX,OFFSET PCXNAM
	MOV	CX,0
	MOV	AH,3CH
	INT	21H			;open output file
	JNC	F650
	PRTSTR	MSG3
	JMP	EXIT
;
F650:	MOV	[WHANDLE],AX		;save output file handle
        MOV     AX,[NXTLIN]
        SHL     AX,1
        SHL     AX,1
        SHL     AX,1
        SHL     AX,1
	MOV	WORD PTR[PCX+66],AX	;bytes per line
	ADD	AX,AX
	ADD	AX,AX
	ADD	AX,AX			;pixels per line
	DEC	AX
	MOV	WORD PTR[PCX+8],AX
;
        MOV     AX,[LHEIGHT]             ;height
        MUL     [LINES]
	DEC	AX
	MOV	WORD PTR[PCX+10],AX
;
	MOV	AX,[WIDT]
	MOV	WORD PTR[PCX+12],AX
;
        MOV     AX,[LHEIGHT]
        MUL     [LINES]
	MOV	WORD PTR[PCX+14],AX
;
	MOV	BX,[WHANDLE]
	MOV	CX,128
	MOV	DX,OFFSET PCX
	MOV	AH,40H
	INT	21H			;write header
	JNC	F652
	PRTSTR	MSG4
	JMP	F670
;
F652:	MOV	ES,[VSCREEN]		;ES=starting segment
	MOV	BP,WORD PTR[PCX+10]
	INC	BP			;BP=number of scan lines
;
F653:	MOV	DI,WORD PTR[PCX+66]	;DI=bytes per line
	MOV	SI,0			;SI=byte pointer
;
F654:	MOV	CL,1			;CX=compression counter
	MOV	AL,ES:[SI]		;AX=pattern
F655:	DEC	DI
	JZ	F656
	INC	SI
	CMP	AL,ES:[SI]		;same as next pattern?
	JNE	F656
	INC	CL
	CMP	CL,63			;maximum count?
	JNE	F655
	INC	SI			;yes, process this byte
	DEC	DI
;
F656:   NOT     AL
        MOV     BX,[WHANDLE]
	MOV	DX,OFFSET PCXDATA
	CMP	CL,1
	JE	F658
F657:	OR	CL,0C0H
	MOV	[PCXDATA],CL
	MOV	[PCXDATA+1],AL
	MOV	CX,2
	MOV	AH,40H
	INT	21H
	CMP	AX,CX
	STC
	JNE	F670
	JMP	F660
;
F658:   MOV     AH,AL
        AND     AH,0C0H
        CMP     AH,0C0H
        JE      F657
	MOV	[PCXDATA],AL
	MOV	CX,1
	MOV	AH,40H
	INT	21H
	CMP	AX,CX
	STC
	JE	F660
	PRTSTR	MSG4
	JMP	F670
;
F660:	CMP	DI,0			;next byte
	JNE	F654
	MOV	AX,ES			;next scan line
	ADD	AX,[NXTLIN]
	MOV	ES,AX
	DEC	BP
	JNE	F653
	CLC
;
F670:	MOV	BX,[RHANDLE]
	MOV	AH,3EH
	INT	21H			;close input file
	MOV	BX,[WHANDLE]
	MOV	AH,3EH
	INT	21H			;close output file
EXIT:   INT     20H
        .XLIST
;
; RDWORD - read input file
;
RDWORD: MOV     BX,[FHANDLE]
        MOV     CX,1
        MOV     DX,OFFSET BIG5
        MOV     AH,3FH
        INT     21H
        JC      RD4
        CMP     AX,1
        JE      RD10
RD4:    MOV     AX,1A1AH
        RET
;
RD10:   MOV     AL,[BIG5]
        CMP     AL,0A1H
        JB      RD100
        CMP     AL,0FEH
        JA      RD100
        MOV     AH,3FH
        MOV     DX,OFFSET BIG5+1
        INT     21H
        JC      RD12
        CMP     AX,1
        JE      RD20
RD12:   MOV     AX,1A1AH
        RET
;
RD20:   MOV     AH,[BIG5]               ;return BIG-5 code
        MOV     AL,[BIG5+1]
        RET
;
RD100:  MOV     AH,0                    ;return ASCII code
        RET
        .LIST
;************************************************
;* read pattern from font file into VSEG:VBPTR	*
;************************************************
GETFNT: PUSH    AX
        MOV     CX,8
        MOV     BX,OFFSET BUF
G20:    MOV     WORD PTR [BX],0         ;clear buffer
        ADD     BX,2
        LOOP    G20
        POP     AX
;
        CALL    CVTSEQ                  ;convert to sequence code
	JNC	G100
        MOV     BX,[ASCSIZ+1]           ;non-BIG5, treat as ASCII
        MUL     BX                      ;DX:AX = code x ASCSIZ/256
        MOV     SI,[CSIZE]
        ADD     SI,[CSPACE]
        SHR     SI,1                    ;SI=character width for half size
        MOV     [CWIDTH],SI
        MOV     SI,[CSIZE]
        SHR     SI,1
        ADD     SI,7
        SHR     SI,1
        SHR     SI,1
        SHR     SI,1
        MOV     [CBSIZE],SI
        JMP     G101
;
G100:   MOV     SI,[CSIZE]              ;SI=character width for full size
        ADD     SI,7
        AND     SI,0FFF8H
        ADD     SI,[CSPACE]
        MOV     [CWIDTH],SI             ;calculate cell width
;
        MOV     SI,[CSIZE]
        ADD     SI,7
        AND     SI,0FFF8H
        SHR     SI,1
        SHR     SI,1
        SHR     SI,1
        MOV     [CBSIZE],SI             ;calculate char width in bytes
        PUSH    AX                      ;save sequence code
;
	MOV	AH,BYTE PTR[CSIZE]
        MOV     AL,AH
        ADD     AL,7
        AND     AL,0F8H
        MUL     AH
        SHR     AX,1
        SHR     AX,1
        SHR     AX,1                    ;AX=bytes per character
;
        POP     BX                      ;bx=sequence code
        MUL     BX                      ;DX:AX=byte offset in file
        ADD     AX,[ASCSIZ]
        ADC     DX,[ASCSIZ+2]
;
;move file pointer
;
G101:   MOV     CX,DX
	MOV	DX,AX
	MOV	AH,42H
	MOV	AL,0
	MOV	BX,[RHANDLE]
        INT     21H
;
;read pattern from font file
;
	MOV	BP,[CSIZE]
        MOV     ES,[VSEG]
G102:   MOV     BX,[RHANDLE]
        MOV     CX,[CBSIZE]
        MOV     DX,OFFSET BUF
	MOV	AH,3FH
	INT	21H
;                                               ;shift BUF
        MOV     BX,[VBPTR]
        MOV     SI,OFFSET BUF
        MOV     DI,[CWIDTH]
        MOV     CH,BL
        AND     CH,7                            ;CH=bit offset
        SHR     BX,1
        SHR     BX,1
        SHR     BX,1                            ;BX=byte offset
G103:   MOV     AH,[SI]
        MOV     AL,0
        OR      CH,CH
        JZ      G104
;
        MOV     CL,CH
        REP     SHR AX,CL                       ;shift pattern to right bit
G104:   OR      ES:[BX],AH
        OR      ES:[BX+1],AL
        INC     BX
        INC     SI
        SUB     DI,8
        JG      G103
;
;        CALL    DBIG5
        INC     [BUFPTR]
	MOV	AX,ES
	ADD	AX,[NXTLIN]
	MOV	ES,AX
	DEC	BP
	JNZ	G102
	CLC
        RET
        .XLIST
;********************************************
;* convert BIG-5 code in AX to sequence code*
;********************************************
CVTSEQ: CALL    BIG5CHK
        JNC     B100
        RET
;
B100:   CMP     AX,0A140H
        JB      B110
        CMP     AX,0A3BFH
        JBE     B120
;
        CMP     AX,0A440H
        JB      B110
        CMP     AX,0C67EH
        JBE     B130
;
        CMP     AX,0C6E7H
        JB      B110
        CMP     AX,0C7F2H
        JBE     B150
;
        CMP     AX,0C940H
        JB      B110
        CMP     AX,0F9FEH
        JBE     B140
;
B110:   STC                     ;non-BIG-5
        RET
;
; A140-13BF, symbols
;
B120:   SUB     AX,0A140H
        CALL    CSEQ
	CLC
	RET
;
; A440-C67E, frequently used
;
B130:   SUB     AX,0A440H
        CALL    CSEQ
        ADD     AX,408
	CLC
	RET
;
; C940-F9FE, occasionally used
;
B140:   SUB     AX,0C940H
        CALL    CSEQ
        ADD     AX,408+5401
	CLC
	RET
;
; C6E7-C7F2, japanese
;
B150:   SUB     AX,0C640H
        CALL    CSEQ
        SUB     AX,130                  ;minus C640-C6E6
        ADD     AX,408+5401+7693
	CLC
        RET
;**************************************
;* CSEQ - convert AX to sequence code *
;**************************************
CSEQ:   CMP     AL,61H
        JB      CS10
        SUB     AL,22H
CS10:   MOV     BL,AL
        MOV     BH,0
        MOV     AL,AH
        MOV     AH,157
        MUL     AH
        ADD     AX,BX
        RET
;****************************************
;* Check if AX contains BIG-5 code      *
;*					*
;* 1st byte = A1-FE			*
;* 2nd byte = 40-7E or A1-FE            *
;****************************************]
BIG5CHK:CMP     AH,0                    ;is it ASCII?
        JNZ     B10
        STC                             ;yes, error
        RET
;
B10:    CMP     AH,0A1H
        JB      B20
        CMP     AH,0FEH
        JA      B20
;
	CMP	AL,40H
        JB      B20
        CMP     AL,7EH
        JA      B15
        CLC
        RET
;
B15:    CMP     AL,0A1H
        JB      B20
        CMP     AL,0FEH
        JA      B20
        CLC
        RET
;
B20:    STC
        RET
;***********************************************
;* put character (one scan line on screen      *
;***********************************************
DBIG5:  MOV     DX,[CWIDTH]
        MOV     SI,OFFSET BUF
;
; Loop for all scan lines
;
DB01:   MOV     AL,[SI]
	MOV	CX,8
;
; Loop to display one byte
;
DB00:	RCL	AL,1
	PUSH	AX
	JC	DB10
	MOV	AL,'.'
	JMP	DB20
;
DB10:	MOV	AL,'X'
DB20:	PRTCHR
	POP	AX
        LOOP    DB00
;
	INC	SI
        SUB     DX,8
        JGE     DB01
;
        PRTCHR  0DH
	PRTCHR	0AH
	RET
;************************
;* parse command line	*
;************************
PARSE:  MOV     BL,DS:[80h]
	CMP	BL,0
        JNE     P10
        JMP     P20
;
P10:    CALL    CVTUC
        MOV     SI,OFFSET 81H
;
P12:    CALL    DEBLANK
        CMP     WORD PTR[SI],'S/'       ;size?
        JE      P100
        CMP     WORD PTR[SI],'L/'       ;line gap?
        JE      P200
        CMP     WORD PTR[SI],'C/'       ;char gap?
        JE      P300
        CMP     BYTE PTR[SI],'/'        ;other?
        JE      P20
        MOV     AL,DS:[80H]
        ADD     AL,80H
        MOV     AH,0
        CMP     AX,SI
        JBE     P500                    ;done
        MOV     DI,OFFSET FILNAM
        CALL    GETNAM
        JMP     P12
;
P20:    PRTSTR  MSG1
        JMP     EXIT
;
; /S:size
;
P100:   CALL    GETVAL
        JC      P20
        MOV     [CSIZE],AX
        JMP     P12
;
; /L:line_gap
;
P200:   CALL    GETVAL
        JC      P20
        MOV     [LINEGAP],AX
        JMP     P12
;
; /C:char_gap
;
P300:   CALL    GETVAL
        JC      P20
        MOV     [CSPACE],AX
        JMP     P12
;
; process file name
;
P500:   MOV     SI,OFFSET FILNAM
        MOV     DI,OFFSET PCXNAM
        CALL    STRCPY                  ;setup output filename
        MOV     SI,OFFSET PCXNAM
P510:   CMP     BYTE PTR [SI],'.'
        JE      P530
        CMP     BYTE PTR [SI],0
        JE      P530
        INC     SI
        JMP     P510
;
P530:   MOV     WORD PTR [SI],'P.'
        MOV     WORD PTR [SI+2],'XC'
        MOV     BYTE PTR [SI+4],0
;
; Determine font file name
;
        MOV     AX,[CSIZE]
        MOV     BX,'15'
        CMP     AX,15
        JE      P540
;
        MOV     BX,'24'
        CMP     AX,24
        JE      P540
;
P540:   MOV     [FNTNAM+6],BH
        MOV     [FNTNAM+7],BL
        RET
;
; Convert to uppercase
;
CVTUC:  MOV     CL,DS:[80H]
        MOV     CH,0
        MOV     SI,81H
CV10:   MOV     AL,[SI]
        CMP     AL,'a'
        JB      CV20
        CMP     AL,'z'
        JA      CV20
        AND     AL,0DFH
CV20:   MOV     [SI],AL
        INC     SI
        LOOP    CV10
        RET
;
; get valine in AX
;
GETVAL: CMP     BYTE PTR[SI+2],':'
        JE      CV2
        JMP     P20
;
CV2:    ADD     SI,3
        CALL    DEBLANK
        MOV     DI,SI
        MOV     CX,0
GV10:   MOV     BL,[SI]
        CMP     BL,'0'
        JB      GV20
        CMP     BL,'9'
        JA      GV20
        SUB     BL,'0'
        MOV     AX,10
        MUL     CX
        MOV     BH,0
        ADD     AX,BX
        MOV     CX,AX
        INC     SI
        JMP     GV10
GV20:   CMP     DI,SI      ;encountered valid digits?
        JE      GV30
        CLC                ;yes, good return
        RET
;
GV30:   STC                ;no, set error status
        RET
;
; Deblank command line
;
DEBLANK:CMP     BYTE PTR[SI],' '
        JNE     DEB10
        INC     SI
        JMP     DEBLANK
DEB10:  RET
;
; Move filename
;
GETNAM: MOV     CL,DS:[80H]
        ADD     CL,81H
        MOV     CH,0                    ;CX=end of command line
MV10:   MOV     AL,[SI]
        CMP     AL,' '
        JE      MV20
        MOV     BYTE PTR[DI],AL
        INC     SI
        INC     DI
        CMP     CX,SI
        JE      MV20
        JMP     MV10
MV20:   RET
;
; ASCIIZ string copy
;
STRCPY: MOV     AL,[SI]
        MOV     [DI],AL
        CMP     AL,0
        JE      SC10
        INC     SI
        INC     DI
        JMP     STRCPY
SC10:   RET
;
MSG0	DB	'BIG-5 code to .PCX conversion - Rev 1.0 Copyright Jerry Chu 1991',0dh,0ah,'$'
MSG1    DB      'USAGE: C2PCX filename [/s:15] [/s:24] [/l:line_gap] [/c:char_gap]',0dh,0ah,'$'
MSG2	DB	'Cannot open font file',0dh,0ah,'$'
MSG3	DB	'Cannot open .PCX file',0dh,0ah,'$'
MSG4    DB      'Error writing .PCX file',0dh,0ah,'$'
MSG5    DB      'Cannot open input file',0dh, 0ah, '$'
;
CSIZE   DW      15                      ;character size (default=15)
LINEGAP DW      6                       ;line spacing (default=6)
CSPACE  DW      4                       ;character space (default=4)
;
RHANDLE	DW	0			;font file handle
WHANDLE DW      0                       ;.PCX file handle
FHANDLE DW      0                       ;input file handle
CBSIZE  DW      0                       ;character width (bytes)
CWIDTH  DW      0                       ;current width (full or half) of input
LHEIGHT DW      0                       ;line height (CSIZE + LINEGAP)
VSCREEN	DW	0
NXTLIN  DW      100
WIDT    DW      1600
VSEG	DW	0			;segment of pointer to image
VBPTR	DW	0			;byte offset of pointer to image
FNTNAM  DB      'C2PCX.',17 DUP (0)
FILNAM  DB      128 DUP (0)
PCXNAM  DB      128 DUP (0)
PCXDATA DB      0,0
BIG5    DB      0,0
ASCSIZ  DW      0,0
LINES   DW      0                       ;text lines
BUF     DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0         ;font file buffer area
BUFPTR  DW      0
LASTSEG DW      0                       ;last memory segment
;
PCX	DB	0AH,3,1,1		;PCX file header
	DW	0,0,0,0 		;XMIN,YMIN,XMAX,YMAX
	DW	0,0			;HEWA,VRES
	DB	0,0,0, 45 DUP (0FFH)	;COLOR MAP
	DB	0,1			;1 COLOR PLANE
	DW	0,0			;BYTES PER LINE
	DB	58 DUP (0)
;
EOP:
	ORG	$+256
STK:
	CSEG	ENDS
	END	BEGIN
